/**
 * A {@link ElementComponent} that contains child {@link ElementComponent}s.
 *
 * @category User Interface
 */ var ELEMENTTYPE_GROUP = 'group';
/**
 * A {@link ElementComponent} that displays an image.
 *
 * @category User Interface
 */ var ELEMENTTYPE_IMAGE = 'image';
/**
 * A {@link ElementComponent} that displays text.
 *
 * @category User Interface
 */ var ELEMENTTYPE_TEXT = 'text';
/**
 * Fit the content exactly to Element's bounding box.
 *
 * @category User Interface
 */ var FITMODE_STRETCH = 'stretch';
/**
 * Fit the content within the Element's bounding box while preserving its Aspect Ratio.
 *
 * @category User Interface
 */ var FITMODE_CONTAIN = 'contain';
/**
 * Fit the content to cover the entire Element's bounding box while preserving its Aspect Ratio.
 *
 * @category User Interface
 */ var FITMODE_COVER = 'cover';

export { ELEMENTTYPE_GROUP, ELEMENTTYPE_IMAGE, ELEMENTTYPE_TEXT, FITMODE_CONTAIN, FITMODE_COVER, FITMODE_STRETCH };
