import { SceneParser } from '../parsers/scene.js';
import { SceneUtils } from './scene-utils.js';
import { ResourceHandler } from './handler.js';

/**
 * @import { AppBase } from '../app-base.js'
 */ class HierarchyHandler extends ResourceHandler {
    load(url, callback) {
        SceneUtils.load(url, this.maxRetries, callback);
    }
    open(url, data) {
        // prevent script initialization until entire scene is open
        this._app.systems.script.preloading = true;
        var parser = new SceneParser(this._app, false);
        var parent = parser.parse(data);
        // re-enable script initialization
        this._app.systems.script.preloading = false;
        return parent;
    }
    /**
     * @param {AppBase} app - The running {@link AppBase}.
     */ constructor(app){
        super(app, 'hierarchy');
    }
}

export { HierarchyHandler };
