import { Debug } from '../../core/debug.js';
import { RenderPass } from '../../platform/graphics/render-pass.js';

/**
 * A render pass used to render post-effects.
 */ class RenderPassPostprocessing extends RenderPass {
    execute() {
        var renderAction = this.renderAction;
        var camera = renderAction.camera;
        Debug.assert(renderAction.triggerPostprocess && camera.onPostprocessing);
        // trigger postprocessing for camera
        camera.onPostprocessing();
    }
    constructor(device, renderer, renderAction){
        super(device);
        this.renderer = renderer;
        this.renderAction = renderAction;
        this.requiresCubemaps = false;
    }
}

export { RenderPassPostprocessing };
