var fresnelSchlickPS = "\n// Schlick's approximation\nvec3 getFresnel(\n        float cosTheta, \n        float gloss, \n        vec3 specularity\n#if defined(LIT_IRIDESCENCE)\n        , vec3 iridescenceFresnel, \n        float iridescenceIntensity\n#endif\n    ) {\n    float fresnel = pow(1.0 - max(cosTheta, 0.0), 5.0);\n    float glossSq = gloss * gloss;\n    vec3 ret = specularity + (max(vec3(glossSq), specularity) - specularity) * fresnel;\n#if defined(LIT_IRIDESCENCE)\n    return mix(ret, iridescenceFresnel, iridescenceIntensity);\n#else\n    return ret;\n#endif    \n}\n\nfloat getFresnelCC(float cosTheta) {\n    float fresnel = pow(1.0 - max(cosTheta, 0.0), 5.0);\n    return 0.04 + (1.0 - 0.04) * fresnel;\n}\n";

export { fresnelSchlickPS as default };
