import { SceneParser } from '../parsers/scene.js';
import { SceneUtils } from './scene-utils.js';
import { ResourceHandler } from './handler.js';

class HierarchyHandler extends ResourceHandler {
		load(url, callback) {
				SceneUtils.load(url, this.maxRetries, callback);
		}
		open(url, data) {
				this._app.systems.script.preloading = true;
				var parser = new SceneParser(this._app, false);
				var parent = parser.parse(data);
				this._app.systems.script.preloading = false;
				return parent;
		}
		constructor(app){
				super(app, 'hierarchy');
		}
}

export { HierarchyHandler };
