import { Entity } from '../entity.js';
import { GSplatInstance } from '../../scene/gsplat/gsplat-instance.js';
import { GSplat } from '../../scene/gsplat/gsplat.js';
import { GSplatCompressed } from '../../scene/gsplat/gsplat-compressed.js';
import { GSplatSogs } from '../../scene/gsplat/gsplat-sogs.js';

class GSplatResource {
		destroy() {
				var _this_splat;
				this.app = null;
				this.splatData = null;
				(_this_splat = this.splat) == null ? void 0 : _this_splat.destroy();
				this.splat = null;
		}
		createSplat() {
				if (!this.splat) {
						var { app, splatData } = this;
						var gsplatClass = splatData.isCompressed ? GSplatCompressed : splatData.isSogs ? GSplatSogs : GSplat;
						this.splat = new gsplatClass(app.graphicsDevice, splatData);
				}
				return this.splat;
		}
		instantiate(options) {
				if (options === void 0) options = {};
				var splatInstance = this.createInstance(options);
				var entity = new Entity(undefined, this.app);
				var component = entity.addComponent('gsplat', {
						instance: splatInstance
				});
				entity.setLocalEulerAngles(0, 0, 180);
				component.customAabb = splatInstance.splat.aabb.clone();
				return entity;
		}
		createInstance(options) {
				if (options === void 0) options = {};
				var splat = this.createSplat();
				return new GSplatInstance(splat, options);
		}
		constructor(app, splatData, comments){
				this.splat = null;
				this.comments = null;
				this.app = app;
				this.splatData = splatData;
				this.comments = comments;
		}
}

export { GSplatResource };
