import ambientPS from './lit/frag/ambient.js';
import basePS from './lit/frag/base.js';
import combinePS from './lit/frag/combine.js';
import cookieBlit2DPS from './internal/frag/cookie-blit-2d.js';
import cookieBlitCubePS from './internal/frag/cookie-blit-cube.js';
import cookieBlitVS from './internal/vert/cookie-blit.js';
import debugOutputPS from './lit/frag/debug-output.js';
import debugProcessFrontendPS from './lit/frag/debug-process-frontend.js';
import decodePS from './common/frag/decode.js';
import encodePS from './common/frag/encode.js';
import endPS from './lit/frag/end.js';
import envAtlasPS from './common/frag/envAtlas.js';
import envProcPS from './common/frag/envProc.js';
import fogPS from './common/frag/fog.js';
import gammaPS from './common/frag/gamma.js';
import immediateLinePS from './internal/frag/immediateLine.js';
import immediateLineVS from './internal/vert/immediateLine.js';
import lightingPS from './lit/frag/lighting/lighting.js';
import litForwardBackendPS from './lit/frag/pass-forward/litForwardBackend.js';
import litForwardDeclarationPS from './lit/frag/pass-forward/litForwardDeclaration.js';
import litForwardMainPS from './lit/frag/pass-forward/litForwardMain.js';
import litForwardPostCodePS from './lit/frag/pass-forward/litForwardPostCode.js';
import litForwardPreCodePS from './lit/frag/pass-forward/litForwardPreCode.js';
import litMainVS from './lit/vert/litMain.js';
import litShaderArgsPS from './standard/frag/litShaderArgs.js';
import litShaderCorePS from './standard/frag/litShaderCore.js';
import morphEvaluationPS from './internal/morph/frag/morphEvaluation.js';
import morphDeclarationPS from './internal/morph/frag/morphDeclaration.js';
import morphPS from './internal/morph/frag/morph.js';
import morphVS from './internal/morph/vert/morph.js';
import normalCoreVS from './common/vert/normalCore.js';
import outputPS from './lit/frag/output.js';
import outputAlphaPS from './lit/frag/outputAlpha.js';
import reprojectPS from './internal/frag/reproject.js';
import reprojectVS from './internal/vert/reproject.js';
import skinVS from './common/vert/skin.js';
import skyboxPS from './skybox/frag/skybox.js';
import skyboxVS from './skybox/vert/skybox.js';
import sphericalPS from './common/frag/spherical.js';
import tonemappingPS from './common/frag/tonemapping/tonemapping.js';
import tonemappingAcesPS from './common/frag/tonemapping/tonemappingAces.js';
import tonemappingAces2PS from './common/frag/tonemapping/tonemappingAces2.js';
import tonemappingFilmicPS from './common/frag/tonemapping/tonemappingFilmic.js';
import tonemappingHejlPS from './common/frag/tonemapping/tonemappingHejl.js';
import tonemappingLinearPS from './common/frag/tonemapping/tonemappingLinear.js';
import tonemappingNeutralPS from './common/frag/tonemapping/tonemappingNeutral.js';
import tonemappingNonePS from './common/frag/tonemapping/tonemappingNone.js';
import transformVS from './common/vert/transform.js';
import transformCoreVS from './common/vert/transformCore.js';
import uv0VS from './lit/vert/uv0.js';
import uv1VS from './lit/vert/uv1.js';
import uvTransformVS from './lit/vert/uvTransform.js';
import uvTransformUniformsPS from './lit/vert/uvTransformUniforms.js';

var shaderChunksWGSL = {
		ambientPS,
		basePS,
		combinePS,
		cookieBlit2DPS,
		cookieBlitCubePS,
		cookieBlitVS,
		debugOutputPS,
		debugProcessFrontendPS,
		decodePS,
		encodePS,
		endPS,
		envAtlasPS,
		envProcPS,
		fogPS,
		gammaPS,
		immediateLinePS,
		immediateLineVS,
		lightBufferDefinesPS: '',
		lightingPS,
		litForwardBackendPS,
		litForwardDeclarationPS,
		litForwardMainPS,
		litForwardPostCodePS,
		litForwardPreCodePS,
		litMainVS,
		litShaderArgsPS,
		litShaderCorePS,
		morphEvaluationPS,
		morphDeclarationPS,
		morphPS,
		morphVS,
		normalCoreVS,
		outputPS,
		outputAlphaPS,
		reprojectPS,
		reprojectVS,
		skinVS,
		skyboxPS,
		skyboxVS,
		sphericalPS,
		tonemappingPS,
		tonemappingAcesPS,
		tonemappingAces2PS,
		tonemappingFilmicPS,
		tonemappingHejlPS,
		tonemappingLinearPS,
		tonemappingNeutralPS,
		tonemappingNonePS,
		transformVS,
		transformCoreVS,
		uv0VS,
		uv1VS,
		uvTransformVS,
		uvTransformUniformsPS
};

export { shaderChunksWGSL };
