var encodePS = "\nvec4 encodeLinear(vec3 source) {\n	return vec4(source, 1.0);\n}\nvec4 encodeGamma(vec3 source) {\n	return vec4(pow(source + 0.0000001, vec3(1.0 / 2.2)), 1.0);\n}\nvec4 encodeRGBM(vec3 source) {\n	vec4 result;\n	result.rgb = pow(source.rgb, vec3(0.5));\n	result.rgb *= 1.0 / 8.0;\n	result.a = saturate( max( max( result.r, result.g ), max( result.b, 1.0 / 255.0 ) ) );\n	result.a = ceil(result.a * 255.0) / 255.0;\n	result.rgb /= result.a;\n	return result;\n}\nvec4 encodeRGBP(vec3 source) {\n	vec3 gamma = pow(source, vec3(0.5));\n	float maxVal = min(8.0, max(1.0, max(gamma.x, max(gamma.y, gamma.z))));\n	float v = 1.0 - ((maxVal - 1.0) / 7.0);\n	v = ceil(v * 255.0) / 255.0;\n	return vec4(gamma / (-v * 7.0 + 8.0), v);	\n}\nvec4 encodeRGBE(vec3 source) {\n	float maxVal = max(source.x, max(source.y, source.z));\n	if (maxVal < 1e-32) {\n		return vec4(0, 0, 0, 0);\n	} else {\n		float e = ceil(log2(maxVal));\n		return vec4(source / pow(2.0, e), (e + 128.0) / 255.0);\n	}\n}\n";

export { encodePS as default };
