var normalCoreVS = "\nattribute vec3 vertex_normal;\n#ifdef MORPHING_NORMAL\n	#ifdef MORPHING_INT\n		uniform highp usampler2D morphNormalTex;\n	#else\n		uniform highp sampler2D morphNormalTex;\n	#endif\n#endif\nvec3 getLocalNormal(vec3 vertexNormal) {\n	vec3 localNormal = vertex_normal;\n	#ifdef MORPHING_NORMAL\n		ivec2 morphUV = getTextureMorphCoords();\n		#ifdef MORPHING_INT\n			vec3 morphNormal = vec3(texelFetch(morphNormalTex, ivec2(morphUV), 0).xyz) / 65535.0 * 2.0 - 1.0;\n		#else\n			vec3 morphNormal = texelFetch(morphNormalTex, ivec2(morphUV), 0).xyz;\n		#endif\n		localNormal += morphNormal;\n	#endif\n	return localNormal;\n}\n#ifdef SKIN\n	mat3 getNormalMatrix(mat4 modelMatrix) {\n		return mat3(modelMatrix[0].xyz, modelMatrix[1].xyz, modelMatrix[2].xyz);\n	}\n#elif defined(INSTANCING)\n	mat3 getNormalMatrix(mat4 modelMatrix) {\n		return mat3(modelMatrix[0].xyz, modelMatrix[1].xyz, modelMatrix[2].xyz);\n	}\n#else\n	mat3 getNormalMatrix(mat4 modelMatrix) {\n		return matrix_normal;\n	}\n#endif\n";

export { normalCoreVS as default };
