declare const _default: "\nuniform highp sampler2D sh_labels_u;\nuniform highp sampler2D sh_labels_l;\nuniform highp sampler2D sh_centroids;\n\nuniform float shN_mins;\nuniform float shN_maxs;\n\nvoid readSHData(in SplatSource source, out vec3 sh[15], out float scale) {\n    // extract spherical harmonics palette index\n    int tu = int(texelFetch(sh_labels_u, source.uv, 0).x * 255.0 * 256.0);\n    int tl = int(texelFetch(sh_labels_l, source.uv, 0).x * 255.0);\n    int n = tu + tl;\n    int u = (n % 64) * 15;\n    int v = n / 64;\n\n    // calculate offset into the centroids texture and read 15 consecutive texels\n    for (int i = 0; i < 15; i++) {\n        sh[i] = mix(vec3(shN_mins), vec3(shN_maxs), texelFetch(sh_centroids, ivec2(u + i, v), 0).xyz);\n    }\n\n    scale = 1.0;\n}\n";
export default _default;
