var lightSheenPS = "\nfloat sheenD(vec3 normal, vec3 h, float roughness) {\n	const float PI = 3.141592653589793;\n	float invR = 1.0 / (roughness * roughness);\n	float cos2h = max(dot(normal, h), 0.0);\n	cos2h *= cos2h;\n	float sin2h = max(1.0 - cos2h, 0.0078125);\n	return (2.0 + invR) * pow(sin2h, invR * 0.5) / (2.0 * PI);\n}\nfloat sheenV(vec3 normal, vec3 viewDir, vec3 light) {\n	float NoV = max(dot(normal, viewDir), 0.000001);\n	float NoL = max(dot(normal, light), 0.000001);\n	return 1.0 / (4.0 * (NoL + NoV - NoL * NoV));\n}\nfloat getLightSpecularSheen(vec3 h, vec3 worldNormal, vec3 viewDir, vec3 lightDirNorm, float sheenGloss) {\n	float D = sheenD(worldNormal, h, sheenGloss);\n	float V = sheenV(worldNormal, viewDir, -lightDirNorm);\n	return D * V;\n}\n";

export { lightSheenPS as default };
