declare const _default: "\n\n#ifdef STD_LIGHTMAP_DIR\n    vec3 dLightmapDir;\n    uniform sampler2D texture_dirLightMap;\n#endif\n\nvoid getLightMap() {\n\n    dLightmap = vec3(1.0);\n\n    #ifdef STD_LIGHT_TEXTURE\n        dLightmap *= {STD_LIGHT_TEXTURE_DECODE}(texture2DBias({STD_LIGHT_TEXTURE_NAME}, {STD_LIGHT_TEXTURE_UV}, textureBias)).{STD_LIGHT_TEXTURE_CHANNEL};\n\n        #ifdef STD_LIGHTMAP_DIR\n            vec3 dir = texture2DBias(texture_dirLightMap, {STD_LIGHT_TEXTURE_UV}, textureBias).xyz * 2.0 - 1.0;\n            float dirDot = dot(dir, dir);\n            dLightmapDir = (dirDot > 0.001) ? dir / sqrt(dirDot) : vec3(0.0);\n        #endif\n    #endif\n\n    #ifdef STD_LIGHT_VERTEX\n        dLightmap *= saturate(vVertexColor.{STD_LIGHT_VERTEX_CHANNEL});\n    #endif\n}\n";
export default _default;
