// The main code of particle system vertex shader
var particle_shaderVS = '\n    #ifdef ANIMTEX\n        uniform vec2 animTexTilesParams;\n        uniform vec4 animTexParams;\n        uniform vec2 animTexIndexParams;\n    #endif\n\n    #if NORMAL == MAP\n        varying mat3 ParticleMat;\n    #endif\n\n    #if NORMAL == VERTEX\n        varying vec3 Normal;\n    #endif\n\n    #ifdef SOFT\n        varying float vDepth;\n    #endif\n\n    #ifdef PARTICLE_GPU\n\n        #include "particle_initVS"\n\n        #ifdef PACK8\n            #include "particleInputRgba8PS"     // why are these PS and not VS?\n        #else\n            #include  "particleInputFloatPS"    // why are these PS and not VS?\n        #endif\n\n        #ifdef SOFT\n            #include "screenDepthPS"\n        #endif\n\n        #include "particleVS"\n\n    #else // PARTICLE_CPU\n\n        #ifdef SOFT\n            #include "screenDepthPS"\n        #endif\n\n        #include "particle_cpuVS"\n\n    #endif\n\n    #ifdef LOCAL_SPACE\n        #include "particle_localShiftVS"\n    #endif\n\n    #ifdef ANIMTEX\n        #ifdef ANIMTEX_LOOP\n            #include "particleAnimFrameLoopVS"\n        #else\n            #include "particleAnimFrameClampVS"\n        #endif\n        #include "particleAnimTexVS"\n    #endif\n\n    // wrap is not used on CPU, it was commented out. TODO: investigate why\n    #ifdef PARTICLE_GPU\n        #ifdef WRAP\n            #include "particle_wrapVS"\n        #endif\n    #endif\n\n    #ifdef ALIGN_TO_MOTION\n        #include "particle_pointAlongVS"\n    #endif\n\n    #ifdef USE_MESH\n        #include "particle_meshVS"\n    #else\n        #ifdef CUSTOM_FACE\n            #include "particle_customFaceVS"\n        #else\n            #include "particle_billboardVS"\n        #endif\n    #endif\n\n    #if NORMAL == VERTEX\n        #include "particle_normalVS"\n    #endif\n\n    #if NORMAL == MAP\n        #include "particle_TBNVS"\n    #endif\n\n    #ifdef STRETCH\n        #include "particle_stretchVS"\n    #endif\n\n\n    #ifdef PARTICLE_GPU\n        #include "particle_endVS"\n    #else // PARTICLE_CPU\n        #include "particle_cpu_endVS"\n    #endif\n\n    #ifdef SOFT\n        #include "particle_softVS"\n    #endif\n\n    }\n';

export { particle_shaderVS as default };
