var normalCoreVS = "\nattribute vertex_normal: vec3f;\n#ifdef MORPHING_NORMAL\n	#ifdef MORPHING_INT\n		uniform morphNormalTex: texture_2d<u32>;\n		uniform morphNormalTexSampler: sampler;\n	#else\n		uniform morphNormalTex: texture_2d<f32>;\n		uniform morphNormalTexSampler: sampler;\n	#endif\n#endif\nfn getLocalNormal(vertexNormal: vec3f) -> vec3f {\n	var localNormal: vec3f = vertexNormal;\n	#ifdef MORPHING_NORMAL\n		let morphUV: vec2i = getTextureMorphCoords();\n		#ifdef MORPHING_INT\n			let morphNormalInt: vec4u = textureLoad(morphNormalTex, morphUV, 0);\n			let morphNormalF: vec3f = vec3f(morphNormalInt.xyz) / 65535.0 * 2.0 - 1.0;\n			localNormal = localNormal + morphNormalF;\n		#else\n			let morphNormal: vec3f = textureLoad(morphNormalTex, morphUV, 0).xyz;\n			localNormal = localNormal + morphNormal;\n		#endif\n	#endif\n	return localNormal;\n}\n#ifdef SKIN\n	fn getNormalMatrix(modelMatrix: mat4x4f) -> mat3x3f {\n		return mat3x3f(modelMatrix[0].xyz, modelMatrix[1].xyz, modelMatrix[2].xyz);\n	}\n#elif defined(INSTANCING)\n	fn getNormalMatrix(modelMatrix: mat4x4f) -> mat3x3f {\n		return mat3x3f(modelMatrix[0].xyz, modelMatrix[1].xyz, modelMatrix[2].xyz);\n	}\n#else\n	fn getNormalMatrix(modelMatrix: mat4x4f) -> mat3x3f {\n		return uniform.matrix_normal;\n	}\n#endif\n";

export { normalCoreVS as default };
