var lightDeclarationPS = "\n#if defined(LIGHT{i})\n	uniform vec3 light{i}_color;\n	#if LIGHT{i}TYPE == DIRECTIONAL\n		uniform vec3 light{i}_direction;\n	#else\n		#define LIT_CODE_LIGHTS_POINT\n		uniform vec3 light{i}_position;\n		uniform float light{i}_radius;\n		#if LIGHT{i}TYPE == SPOT\n			#define LIT_CODE_LIGHTS_SPOT\n			uniform vec3 light{i}_direction;\n			uniform float light{i}_innerConeAngle;\n			uniform float light{i}_outerConeAngle;\n		#endif\n	#endif\n	#if LIGHT{i}SHAPE != PUNCTUAL\n		#define LIT_CODE_FALLOFF_SQUARED\n		#if LIGHT{i}TYPE == DIRECTIONAL\n			uniform vec3 light{i}_position;\n		#endif\n		uniform vec3 light{i}_halfWidth;\n		uniform vec3 light{i}_halfHeight;\n	#else\n		#if LIGHT{i}FALLOFF == LINEAR\n			#define LIT_CODE_FALLOFF_LINEAR\n		#endif\n		#if LIGHT{i}FALLOFF == INVERSESQUARED\n			#define LIT_CODE_FALLOFF_SQUARED\n		#endif\n	#endif\n	#if defined(LIGHT{i}CASTSHADOW)\n		uniform mat4 light{i}_shadowMatrix;\n		uniform float light{i}_shadowIntensity;\n		uniform vec4 light{i}_shadowParams;\n		#if LIGHT{i}SHADOWTYPE == PCSS_32F\n			uniform float light{i}_shadowSearchArea;\n			uniform vec4 light{i}_cameraParams;\n			#if LIGHT{i}TYPE == DIRECTIONAL\n				uniform vec4 light{i}_softShadowParams;\n			#endif\n		#endif\n		#if LIGHT{i}TYPE == DIRECTIONAL\n			uniform mat4 light{i}_shadowMatrixPalette[4];\n			uniform vec4 light{i}_shadowCascadeDistances;\n			uniform int light{i}_shadowCascadeCount;\n			uniform float light{i}_shadowCascadeBlend;\n		#endif\n		#if LIGHT{i}TYPE == OMNI\n			#if defined(LIGHT{i}SHADOW_PCF)\n				uniform samplerCubeShadow light{i}_shadowMap;\n			#else\n				uniform samplerCube light{i}_shadowMap;\n			#endif\n		#else\n			#if defined(LIGHT{i}SHADOW_PCF)\n				uniform sampler2DShadow light{i}_shadowMap;\n			#else\n				uniform sampler2D light{i}_shadowMap;\n			#endif\n		#endif\n	#endif\n	#if defined(LIGHT{i}COOKIE)\n		#define LIT_CODE_COOKIE\n		#if LIGHT{i}TYPE == OMNI\n			uniform samplerCube light{i}_cookie;\n			uniform float light{i}_cookieIntensity;\n			#if !defined(LIGHT{i}CASTSHADOW)\n				uniform mat4 light{i}_shadowMatrix;\n			#endif\n		#endif\n		#if LIGHT{i}TYPE == SPOT\n			uniform sampler2D light{i}_cookie;\n			uniform float light{i}_cookieIntensity;\n			#if !defined(LIGHT{i}CASTSHADOW)\n				uniform mat4 light{i}_shadowMatrix;\n			#endif\n			#if defined(LIGHT{i}COOKIE_TRANSFORM)\n				uniform vec4 light{i}_cookieMatrix;\n				uniform vec2 light{i}_cookieOffset;\n			#endif\n		#endif\n	#endif\n#endif\n";

export { lightDeclarationPS as default };
