var lightFunctionLightPS = "\n#if defined(LIGHT{i})\nvoid evaluateLight{i}(\n	#if defined(LIT_IRIDESCENCE)\n		vec3 iridescenceFresnel\n	#endif\n) {\n	vec3 lightColor = light{i}_color;\n	#if LIGHT{i}TYPE == DIRECTIONAL && !defined(LIT_SHADOW_CATCHER)\n		if (all(equal(lightColor, vec3(0.0)))) {\n			return;\n		}\n	#endif\n	#if LIGHT{i}TYPE == DIRECTIONAL\n		dLightDirNormW = light{i}_direction;\n		dAtten = 1.0;\n	#else\n		\n		vec3 lightDirW;\n		evalOmniLight(light{i}_position, lightDirW, dLightDirNormW);\n		#if defined(LIGHT{i}COOKIE)\n			#if LIGHT{i}TYPE == SPOT\n				#ifdef LIGHT{i}COOKIE_FALLOFF\n					#ifdef LIGHT{i}COOKIE_TRANSFORM\n						vec3 cookieAttenuation = getCookie2DXform(light{i}_cookie, light{i}_shadowMatrix, light{i}_cookieIntensity, light{i}_cookieMatrix, light{i}_cookieOffset).{LIGHT{i}COOKIE_CHANNEL};\n					#else\n						vec3 cookieAttenuation = getCookie2D(light{i}_cookie, light{i}_shadowMatrix, light{i}_cookieIntensity).{LIGHT{i}COOKIE_CHANNEL};\n					#endif\n				#else\n					#ifdef LIGHT{i}COOKIE_TRANSFORM\n						vec3 cookieAttenuation = getCookie2DClipXform(light{i}_cookie, light{i}_shadowMatrix, light{i}_cookieIntensity, light{i}_cookieMatrix, light{i}_cookieOffset).{LIGHT{i}COOKIE_CHANNEL};\n					#else\n						vec3 cookieAttenuation = getCookie2DClip(light{i}_cookie, light{i}_shadowMatrix, light{i}_cookieIntensity).{LIGHT{i}COOKIE_CHANNEL};\n					#endif\n				#endif\n			#endif\n			#if LIGHT{i}TYPE == OMNI\n				vec3 cookieAttenuation = getCookieCube(light{i}_cookie, light{i}_shadowMatrix, light{i}_cookieIntensity).{LIGHT{i}COOKIE_CHANNEL};\n			#endif\n			lightColor *= cookieAttenuation;\n		#endif\n		#if LIGHT{i}SHAPE == PUNCTUAL\n			#if LIGHT{i}FALLOFF == LINEAR\n				dAtten = getFalloffLinear(light{i}_radius, lightDirW);\n			#else\n				dAtten = getFalloffInvSquared(light{i}_radius, lightDirW);\n			#endif\n		#else\n			dAtten = getFalloffWindow(light{i}_radius, lightDirW);\n		#endif\n		#if LIGHT{i}TYPE == SPOT\n			#if !defined(LIGHT{i}COOKIE) || defined(LIGHT{i}COOKIE_FALLOFF)\n				dAtten *= getSpotEffect(light{i}_direction, light{i}_innerConeAngle, light{i}_outerConeAngle, dLightDirNormW);\n			#endif\n		#endif\n	#endif\n	if (dAtten < 0.00001) {\n		return;\n	}\n	#if LIGHT{i}SHAPE != PUNCTUAL\n		#if LIGHT{i}SHAPE == RECT\n			calcRectLightValues(light{i}_position, light{i}_halfWidth, light{i}_halfHeight);\n		#elif LIGHT{i}SHAPE == DISK\n			calcDiskLightValues(light{i}_position, light{i}_halfWidth, light{i}_halfHeight);\n		#elif LIGHT{i}SHAPE == SPHERE\n			calcSphereLightValues(light{i}_position, light{i}_halfWidth, light{i}_halfHeight);\n		#endif\n	#endif\n	#if LIGHT{i}SHAPE != PUNCTUAL\n		#if LIGHT{i}TYPE == DIRECTIONAL\n			float attenDiffuse = getLightDiffuse(litArgs_worldNormal, dViewDirW, dLightDirNormW);\n		#else\n			#if LIGHT{i}SHAPE == RECT\n				float attenDiffuse = getRectLightDiffuse(litArgs_worldNormal, dViewDirW, lightDirW, dLightDirNormW) * 16.0;\n			#elif LIGHT{i}SHAPE == DISK\n				float attenDiffuse = getDiskLightDiffuse(litArgs_worldNormal, dViewDirW, lightDirW, dLightDirNormW) * 16.0;\n			#elif LIGHT{i}SHAPE == SPHERE\n				float attenDiffuse = getSphereLightDiffuse(litArgs_worldNormal, dViewDirW, lightDirW, dLightDirNormW) * 16.0;\n			#endif\n		#endif\n	#else\n		dAtten *= getLightDiffuse(litArgs_worldNormal, vec3(0.0), dLightDirNormW);\n	#endif\n	#ifdef LIGHT{i}CASTSHADOW\n		#if LIGHT{i}TYPE == DIRECTIONAL\n			float shadow = getShadow{i}(vec3(0.0));\n		#else\n			float shadow = getShadow{i}(lightDirW);\n		#endif\n		shadow = mix(1.0, shadow, light{i}_shadowIntensity);\n		dAtten *= shadow;\n		#if defined(LIT_SHADOW_CATCHER) && LIGHT{i}TYPE == DIRECTIONAL\n			dShadowCatcher *= shadow;\n		#endif			\n	#endif\n	#if LIGHT{i}SHAPE != PUNCTUAL\n		#ifdef LIT_SPECULAR\n			dDiffuseLight += ((attenDiffuse * dAtten) * lightColor) * (1.0 - dLTCSpecFres);\n		#else\n			dDiffuseLight += (attenDiffuse * dAtten) * lightColor;\n		#endif						\n	#else\n		#if defined(AREA_LIGHTS) && defined(LIT_SPECULAR)\n			dDiffuseLight += (dAtten * lightColor) * (1.0 - litArgs_specularity);\n		#else\n			dDiffuseLight += dAtten * lightColor;\n		#endif\n	#endif\n	#ifdef LIGHT{i}AFFECT_SPECULARITY\n		#if LIGHT{i}SHAPE != PUNCTUAL\n			#ifdef LIT_CLEARCOAT\n				#if LIGHT{i}SHAPE == RECT\n					ccSpecularLight += ccLTCSpecFres * getRectLightSpecular(litArgs_clearcoat_worldNormal, dViewDirW) * dAtten * lightColor;\n				#elif LIGHT{i}SHAPE == DISK\n					ccSpecularLight += ccLTCSpecFres * getDiskLightSpecular(litArgs_clearcoat_worldNormal, dViewDirW) * dAtten * lightColor;\n				#elif LIGHT{i}SHAPE == SPHERE\n					ccSpecularLight += ccLTCSpecFres * getSphereLightSpecular(litArgs_clearcoat_worldNormal, dViewDirW) * dAtten * lightColor;\n				#endif\n			#endif\n			#ifdef LIT_SPECULAR\n				#if LIGHT{i}SHAPE == RECT\n					dSpecularLight += dLTCSpecFres * getRectLightSpecular(litArgs_worldNormal, dViewDirW) * dAtten * lightColor;\n				#elif LIGHT{i}SHAPE == DISK\n					dSpecularLight += dLTCSpecFres * getDiskLightSpecular(litArgs_worldNormal, dViewDirW) * dAtten * lightColor;\n				#elif LIGHT{i}SHAPE == SPHERE\n					dSpecularLight += dLTCSpecFres * getSphereLightSpecular(litArgs_worldNormal, dViewDirW) * dAtten * lightColor;\n				#endif\n			#endif\n		#else\n			#if LIGHT{i}TYPE == DIRECTIONAL && LIT_FRESNEL_MODEL != NONE\n				#define LIGHT{i}FRESNEL\n			#endif\n			#ifdef LIT_SPECULAR\n				vec3 halfDirW = normalize(-dLightDirNormW + dViewDirW);\n			#endif\n			#ifdef LIT_CLEARCOAT\n				vec3 lightspecularCC = getLightSpecular(halfDirW, ccReflDirW, litArgs_clearcoat_worldNormal, dViewDirW, dLightDirNormW, litArgs_clearcoat_gloss, dTBN) * dAtten * lightColor;\n				#ifdef LIGHT{i}FRESNEL\n					lightspecularCC *= getFresnelCC(dot(dViewDirW, halfDirW));\n				#endif\n				ccSpecularLight += lightspecularCC;\n			#endif\n			#ifdef LIT_SHEEN\n				sSpecularLight += getLightSpecularSheen(halfDirW, litArgs_worldNormal, dViewDirW, dLightDirNormW, litArgs_sheen_gloss) * dAtten * lightColor;\n			#endif\n			#ifdef LIT_SPECULAR\n				vec3 lightSpecular = getLightSpecular(halfDirW, dReflDirW, litArgs_worldNormal, dViewDirW, dLightDirNormW, litArgs_gloss, dTBN) * dAtten * lightColor;\n				#ifdef LIGHT{i}FRESNEL\n					#if defined(LIT_IRIDESCENCE)\n						lightSpecular *= getFresnel(dot(dViewDirW, halfDirW), litArgs_gloss, litArgs_specularity, iridescenceFresnel, litArgs_iridescence_intensity);\n					#else\n						lightSpecular *= getFresnel(dot(dViewDirW, halfDirW), litArgs_gloss, litArgs_specularity);\n					#endif\n				#else\n					lightSpecular *= litArgs_specularity;\n				#endif\n				\n				dSpecularLight += lightSpecular;\n			#endif\n		#endif\n	#endif\n}\n#endif\n";

export { lightFunctionLightPS as default };
