declare const _default: "\n\n#ifndef _DECODE_INCLUDED_\n#define _DECODE_INCLUDED_\n\nfn decodeLinear(raw: vec4f) -> vec3f {\n    return raw.rgb;\n}\n\nfn decodeGammaFloat(raw: f32) -> f32 {\n    return pow(raw, 2.2);\n}\n\nfn decodeGamma3(raw: vec3f) -> vec3f {\n    return pow(raw, vec3f(2.2));\n}\n\nfn decodeGamma(raw: vec4f) -> vec3f {\n    return pow(raw.xyz, vec3f(2.2));\n}\n\nfn decodeRGBM(raw: vec4f) -> vec3f {\n    let color = (8.0 * raw.a) * raw.rgb;\n    return color * color;\n}\n\nfn decodeRGBP(raw: vec4f) -> vec3f {\n    let color = raw.rgb * (-raw.a * 7.0 + 8.0);\n    return color * color;\n}\n\nfn decodeRGBE(raw: vec4f) -> vec3f {\n    return select(vec3f(0.0), raw.xyz * pow(2.0, raw.w * 255.0 - 128.0), raw.a != 0.0);\n}\n\nfn passThrough(raw: vec4f) -> vec4f {\n    return raw;\n}\n\nfn unpackNormalXYZ(nmap: vec4f) -> vec3f {\n    return nmap.xyz * 2.0 - 1.0;\n}\n\nfn unpackNormalXY(nmap: vec4f) -> vec3f {\n    var xy = nmap.wy * 2.0 - 1.0;\n    return vec3f(xy, sqrt(1.0 - clamp(dot(xy, xy), 0.0, 1.0)));\n}\n\n#endif\n";
export default _default;
