declare const _default: "\n#include \"gsplatCommonVS\"\n\nvarying mediump vec2 gaussianUV;\nvarying mediump vec4 gaussianColor;\n\n#ifndef DITHER_NONE\n    varying float id;\n#endif\n\nmediump vec4 discardVec = vec4(0.0, 0.0, 2.0, 1.0);\n\n#ifdef PREPASS_PASS\n    varying float vLinearDepth;\n#endif\n\nvoid main(void) {\n    // read gaussian details\n    SplatSource source;\n    if (!initSource(source)) {\n        gl_Position = discardVec;\n        return;\n    }\n\n    vec3 modelCenter = readCenter(source);\n\n    SplatCenter center;\n    if (!initCenter(modelCenter, center)) {\n        gl_Position = discardVec;\n        return;\n    }\n\n    // project center to screen space\n    SplatCorner corner;\n    if (!initCorner(source, center, corner)) {\n        gl_Position = discardVec;\n        return;\n    }\n\n    // read color\n    vec4 clr = readColor(source);\n\n    #if GSPLAT_AA\n        // apply AA compensation\n        clr.a *= corner.aaFactor;\n    #endif\n\n    // evaluate spherical harmonics\n    #if SH_BANDS > 0\n        // calculate the model-space view direction\n        vec3 dir = normalize(center.view * mat3(center.modelView));\n        clr.xyz += evalSH(source, dir);\n    #endif\n\n    clipCorner(corner, clr.w);\n\n    // write output\n    gl_Position = center.proj + vec4(corner.offset, 0, 0);\n    gaussianUV = corner.uv;\n    gaussianColor = vec4(prepareOutputFromGamma(max(clr.xyz, 0.0)), clr.w);\n\n    #ifndef DITHER_NONE\n        id = float(source.id);\n    #endif\n\n    #ifdef PREPASS_PASS\n        vLinearDepth = -center.view.z;\n    #endif\n}\n";
export default _default;
