declare const _default: "\n\n#ifdef LIT_CLUSTERED_LIGHTS\n    // all this functionality that needs to be included for clustered lighting\n    #define LIT_CODE_FALLOFF_LINEAR\n    #define LIT_CODE_FALLOFF_SQUARED\n    #define LIT_CODE_LIGHTS_POINT\n    #define LIT_CODE_LIGHTS_SPOT\n#endif\n\n#ifdef AREA_LIGHTS\n    uniform highp sampler2D areaLightsLutTex1;\n    uniform highp sampler2D areaLightsLutTex2;\n#endif\n\n#ifdef LIT_LIGHTING\n    #include \"lightDiffuseLambertPS\"\n\n    // area lights\n    #if defined(AREA_LIGHTS) || defined(LIT_CLUSTERED_AREA_LIGHTS)\n        #include \"ltcPS\"\n    #endif\n#endif\n\n#ifdef SHADOW_DIRECTIONAL\n    #include \"shadowCascadesPS\"\n#endif\n\n#if defined(SHADOW_KIND_PCF1)\n    #include \"shadowPCF1PS\"\n#endif\n\n#if defined(SHADOW_KIND_PCF3)\n    #include \"shadowPCF3PS\"\n#endif\n\n#if defined(SHADOW_KIND_PCF5)\n    #include \"shadowPCF5PS\"\n#endif\n\n#if defined(SHADOW_KIND_PCSS)\n    #include \"linearizeDepthPS\"\n    #include \"shadowPCSSPS\"\n    #include \"shadowSoftPS\"\n#endif\n\n#if defined(SHADOW_KIND_VSM)\n    #include \"shadowEVSMPS\"\n#endif\n\n#ifdef LIT_CODE_FALLOFF_LINEAR\n    #include \"falloffLinearPS\"\n#endif\n\n#ifdef LIT_CODE_FALLOFF_SQUARED\n    #include \"falloffInvSquaredPS\"\n#endif\n\n#ifdef LIT_CODE_LIGHTS_POINT\n    #include \"lightDirPointPS\"\n#endif\n\n#ifdef LIT_CODE_LIGHTS_SPOT\n    #include \"spotPS\"\n#endif\n\n#ifdef LIT_CODE_COOKIE\n    #include \"cookiePS\"\n#endif\n\n// clustered lighting\n#ifdef LIT_CLUSTERED_LIGHTS\n    #include \"clusteredLightPS\"\n#endif\n\n#ifdef LIGHT_COUNT > 0\n    // LOOP - generate shadow evaluation functions for all non-clustered lights\n    #include \"lightFunctionShadowPS, LIGHT_COUNT\"\n\n    // LOOP - generate light evaluation functions for all non-clustered lights\n    #include \"lightFunctionLightPS, LIGHT_COUNT\"\n#endif\n";
export default _default;
