declare const _default: "\n    #if NORMAL != NONE\n        #if NORMAL == VERTEX\n            varying vec3 Normal;\n        #endif\n\n        #if NORMAL == MAP\n            varying mat3 ParticleMat;\n        #endif\n\n        uniform vec3 lightCube[6];\n    #endif\n\n    #ifdef SOFT\n        varying float vDepth;\n        #include \"screenDepthPS\"\n    #endif\n\n    #include \"gammaPS\"\n    #include \"tonemappingPS\"\n    #include \"fogPS\"\n\n    #if NORMAL == MAP\n        uniform sampler2D normalMap;\n    #endif\n\n    #include \"particlePS\"\n\n    #ifdef SOFT\n        #include \"particle_softPS\"\n    #endif\n\n    #if NORMAL == VERTEX\n        vec3 normal = Normal;\n    #endif\n\n    #if NORMAL == MAP\n        #include \"particle_normalMapPS\"\n    #endif\n\n    #if NORMAL != NONE\n        #ifdef HALF_LAMBERT\n            #include \"particle_halflambertPS\"\n        #else\n            #include \"particle_lambertPS\"\n        #endif\n\n        #include \"particle_lightingPS\"\n    #endif\n\n    #if BLEND == NORMAL\n        #include \"particle_blendNormalPS\"\n    #elif BLEND == ADDITIVE\n        #include \"particle_blendAddPS\"\n    #elif BLEND == MULTIPLICATIVE\n        #include \"particle_blendMultiplyPS\"\n    #endif\n\n    #include \"particle_endPS\"\n";
export default _default;
