var particleVS = "\nvec3 unpack3NFloats(float src) {\n	float r = fract(src);\n	float g = fract(src * 256.0);\n	float b = fract(src * 65536.0);\n	return vec3(r, g, b);\n}\nfloat saturate(float x) {\n	return clamp(x, 0.0, 1.0);\n}\nvec4 tex1Dlod_lerp(TEXTURE_ACCEPT_HIGHP(tex), vec2 tc) {\n	return mix( texture2D(tex,tc), texture2D(tex,tc + graphSampleSize), fract(tc.x*graphNumSamples) );\n}\nvec4 tex1Dlod_lerp(TEXTURE_ACCEPT_HIGHP(tex), vec2 tc, out vec3 w) {\n	vec4 a = texture2D(tex,tc);\n	vec4 b = texture2D(tex,tc + graphSampleSize);\n	float c = fract(tc.x*graphNumSamples);\n	vec3 unpackedA = unpack3NFloats(a.w);\n	vec3 unpackedB = unpack3NFloats(b.w);\n	w = mix(unpackedA, unpackedB, c);\n	return mix(a, b, c);\n}\nvec2 rotate(vec2 quadXY, float pRotation, out mat2 rotMatrix) {\n	float c = cos(pRotation);\n	float s = sin(pRotation);\n	mat2 m = mat2(c, -s, s, c);\n	rotMatrix = m;\n	return m * quadXY;\n}\nvec3 billboard(vec3 InstanceCoords, vec2 quadXY) {\n	#ifdef SCREEN_SPACE\n		vec3 pos = vec3(-1, 0, 0) * quadXY.x + vec3(0, -1, 0) * quadXY.y;\n	#else\n		vec3 pos = -matrix_viewInverse[0].xyz * quadXY.x + -matrix_viewInverse[1].xyz * quadXY.y;\n	#endif\n	return pos;\n}\nvec3 customFace(vec3 InstanceCoords, vec2 quadXY) {\n	vec3 pos = faceTangent * quadXY.x + faceBinorm * quadXY.y;\n	return pos;\n}\nvec2 safeNormalize(vec2 v) {\n	float l = length(v);\n	return (l > 1e-06) ? v / l : v;\n}\nvoid main(void) {\n	vec3 meshLocalPos = particle_vertexData.xyz;\n	float id = floor(particle_vertexData.w);\n	float rndFactor = fract(sin(id + 1.0 + seed));\n	vec3 rndFactor3 = vec3(rndFactor, fract(rndFactor*10.0), fract(rndFactor*100.0));\n	float uv = id / numParticlesPot;\n	readInput(uv);\n#ifdef LOCAL_SPACE\n	inVel = mat3(matrix_model) * inVel;\n#endif\n	vec2 velocityV = safeNormalize((mat3(matrix_view) * inVel).xy);\n	float particleLifetime = lifetime;\n	if (inLife <= 0.0 || inLife > particleLifetime || !inShow) meshLocalPos = vec3(0.0);\n	vec2 quadXY = meshLocalPos.xy;\n	float nlife = clamp(inLife / particleLifetime, 0.0, 1.0);\n	vec3 paramDiv;\n	vec4 params = tex1Dlod_lerp(TEXTURE_PASS(internalTex2), vec2(nlife, 0), paramDiv);\n	float scale = params.y;\n	float scaleDiv = paramDiv.x;\n	float alphaDiv = paramDiv.z;\n	scale += (scaleDiv * 2.0 - 1.0) * scaleDivMult * fract(rndFactor*10000.0);\n#ifndef USE_MESH\n	texCoordsAlphaLife = vec4(quadXY * -0.5 + 0.5, (alphaDiv * 2.0 - 1.0) * alphaDivMult * fract(rndFactor*1000.0), nlife);\n#else\n	texCoordsAlphaLife = vec4(particle_uv, (alphaDiv * 2.0 - 1.0) * alphaDivMult * fract(rndFactor*1000.0), nlife);\n#endif\n	vec3 particlePos = inPos;\n	vec3 particlePosMoved = vec3(0.0);\n	mat2 rotMatrix;\n";

export { particleVS as default };
