var stdFrontEndPS = '\n	#if LIT_BLEND_TYPE != NONE || defined(LIT_ALPHA_TEST) || defined(LIT_ALPHA_TO_COVERAGE) || STD_OPACITY_DITHER != NONE\n		#ifdef STD_OPACITY_TEXTURE_ALLOCATE\n			uniform sampler2D texture_opacityMap;\n		#endif\n		#include "opacityPS"\n	#endif\n	#ifdef FORWARD_PASS\n		#ifdef STD_HEIGHT_MAP\n			#include "parallaxPS"\n		#endif\n		#include  "diffusePS"\n		#ifdef LIT_NEEDS_NORMAL\n			#include "normalMapPS"\n		#endif\n		#ifdef LIT_REFRACTION\n			#include "transmissionPS"\n			#include "thicknessPS"\n		#endif\n		#ifdef LIT_IRIDESCENCE\n			#include "iridescencePS"\n			#include "iridescenceThicknessPS"\n		#endif\n		#ifdef LIT_SPECULAR_OR_REFLECTION\n			#ifdef LIT_SHEEN\n				#include "sheenPS"\n				#include "sheenGlossPS"\n			#endif\n			#ifdef LIT_METALNESS\n				#include "metalnessPS"\n				#include "iorPS"\n			#endif\n			#ifdef LIT_SPECULARITY_FACTOR\n				#include "specularityFactorPS"\n			#endif\n			#ifdef STD_SPECULAR_COLOR\n				#include "specularPS"\n			#else\n				void getSpecularity() { \n					dSpecularity = vec3(1);\n				}\n			#endif\n			#include "glossPS"\n		#endif\n		#ifdef STD_AO\n			#include "aoPS"\n		#endif\n		#include "emissivePS"\n		#ifdef LIT_CLEARCOAT\n			#include "clearCoatPS"\n			#include "clearCoatGlossPS"\n			#include "clearCoatNormalPS"\n		#endif\n		#if defined(STD_LIGHTMAP) || defined(STD_LIGHT_VERTEX_COLOR)\n			#include "lightmapPS"\n		#endif\n	#endif\n	void evaluateFrontend() {\n		#if LIT_BLEND_TYPE != NONE || defined(LIT_ALPHA_TEST) || defined(LIT_ALPHA_TO_COVERAGE) || STD_OPACITY_DITHER != NONE\n			getOpacity();\n			#if defined(LIT_ALPHA_TEST)\n				alphaTest(dAlpha);\n			#endif\n			#if STD_OPACITY_DITHER != NONE\n				opacityDither(dAlpha, 0.0);\n			#endif\n			litArgs_opacity = dAlpha;\n		#endif\n		#ifdef FORWARD_PASS\n			#ifdef STD_HEIGHT_MAP\n				getParallax();\n			#endif\n			getAlbedo();\n			litArgs_albedo = dAlbedo;\n			#ifdef LIT_NEEDS_NORMAL\n				getNormal();\n				litArgs_worldNormal = dNormalW;\n			#endif\n			#ifdef LIT_REFRACTION\n				getRefraction();\n				litArgs_transmission = dTransmission;\n				getThickness();\n				litArgs_thickness = dThickness;\n				#ifdef LIT_DISPERSION\n					litArgs_dispersion = material_dispersion;\n				#endif\n			#endif\n			#ifdef LIT_IRIDESCENCE\n				getIridescence();\n				getIridescenceThickness();\n				litArgs_iridescence_intensity = dIridescence;\n				litArgs_iridescence_thickness = dIridescenceThickness;\n			#endif\n			#ifdef LIT_SPECULAR_OR_REFLECTION\n				#ifdef LIT_SHEEN\n					getSheen();\n					litArgs_sheen_specularity = sSpecularity;\n					getSheenGlossiness();\n					litArgs_sheen_gloss = sGlossiness;\n				#endif\n				#ifdef LIT_METALNESS\n					getMetalness();\n					litArgs_metalness = dMetalness;\n					getIor();\n					litArgs_ior = dIor;\n				#endif\n				#ifdef LIT_SPECULARITY_FACTOR\n					getSpecularityFactor();\n					litArgs_specularityFactor = dSpecularityFactor;\n				#endif\n				getGlossiness();\n				getSpecularity();\n				litArgs_specularity = dSpecularity;\n				litArgs_gloss = dGlossiness;\n			#endif\n			#ifdef STD_AO\n				getAO();\n				litArgs_ao = dAo;\n			#endif\n			getEmission();\n			litArgs_emission = dEmission;\n			#ifdef LIT_CLEARCOAT\n				getClearCoat();\n				getClearCoatGlossiness();\n				getClearCoatNormal();\n				litArgs_clearcoat_specularity = ccSpecularity;\n				litArgs_clearcoat_gloss = ccGlossiness;\n				litArgs_clearcoat_worldNormal = ccNormalW;\n			#endif\n			#if defined(STD_LIGHTMAP) || defined(STD_LIGHT_VERTEX_COLOR)\n				getLightMap();\n				litArgs_lightmap = dLightmap;\n				#ifdef STD_LIGHTMAP_DIR\n					litArgs_lightmapDir = dLightmapDir;\n				#endif\n			#endif\n		#endif\n	}\n';

export { stdFrontEndPS as default };
